<script setup lang="ts">
import { ref } from 'vue'
import UserApiV1 from '@/api/userApi'

const props = defineProps({
  userData: {
    type: Object,
    default: () => ({}),
  },
})

const saving = ref(false)
const isRequest = ref(false)
const isError = ref(false)
const requestMessage = ref('')

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')

async function saveUser() {
  // Need to restart isRequest value for show again if you close it
  isRequest.value = false
  saving.value = true

  const users = new UserApiV1()
  try {
    const response = await users.updateUser(props.userData)

    requestMessage.value = response.data.message
    isError.value = false
  }
  catch (error) {
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  finally {
    saving.value = false
    isRequest.value = true
  }
}
</script>

<template>
  <VForm ref="form">
    <VRow>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <h6 class="text-h6 font-weight-medium">
          Account Details [{{ props.userData.username }}] - ({{ props.userData.id }})
        </h6>
        <p class="mb-0">
          Enter your Account Details
        </p>
      </VCol>
    </VRow>

    <VRow>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.userData.username"
          label="Username"
          name="username"
          disabled
          readonly
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.userData.email"
          label="Email"
          placeholder="Email"
          name="email"
          type="email"
          :disabled="!props.userData.internal"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.userData.name"
          label="Name"
          placeholder="Name"
          name="name"
          :disabled="!props.userData.internal"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.userData.surname_1"
          label="Surname"
          placeholder="Surname"
          name="surname_1"
          :disabled="!props.userData.internal"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.userData.surname_2"
          label="Second surname"
          placeholder="Second surname"
          name="surname_2"
        />
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol md="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :border-color="alertToggleVariant"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          variant="tonal"
          dense
          closable
        >
          <VIcon left>
            mdi-information
          </VIcon>
          {{ alertToggleText }} {{ requestMessage }}
        </VAlert>
      </VCol>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <VBtn
          color="primary"
          class="mt-2 mr-1"
          :disabled="saving"
          @click="saveUser"
        >
          <VProgressCircular
            v-if="saving"
            indeterminate
            size="14"
          />
          <span v-if="saving"> Saving... </span>
          <span v-else> Save changes </span>
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>
</style>
